//+----------------------------------------------------------------------------------+
//|                                                  bulliz - high low indicator.mq4 |
//|                                                                           mladen |
//+----------------------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 DeepSkyBlue
#property indicator_color4 PaleVioletRed
#property indicator_color5 DimGray
#property indicator_color6 DimGray
#property indicator_style1 STYLE_DOT
#property indicator_style2 STYLE_DOT
#property indicator_width3 2
#property indicator_width4 2

//
//
//
//
//

extern int    PriceToMonitor    = PRICE_CLOSE;
extern string HighLowPricesFrom = "00:00";
extern string HighLowPricesTo   = "03:59";

//
//
//
//
//

double bufferUp[];
double bufferDn[];
double bufferBau[];
double bufferBad[];
double bufferBbu[];
double bufferBbd[];
double trend[];

string startTime;
string endTime;


//+----------------------------------------------------------------------------------+
//|                                                                                  |
//+----------------------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,bufferUp);
   SetIndexBuffer(1,bufferDn);
   SetIndexBuffer(2,bufferBau); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,bufferBad); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,bufferBbu); SetIndexStyle(4,DRAW_HISTOGRAM);
   SetIndexBuffer(5,bufferBbd); SetIndexStyle(5,DRAW_HISTOGRAM);
   SetIndexBuffer(6,trend);

      IndicatorShortName("High low indicator");

      //
      //
      //
      //
      //
      
      startTime = normalizeTime(HighLowPricesFrom);
      endTime   = normalizeTime(HighLowPricesTo);
   return(0);
}
int deinit()
{
   Comment(""); return(0);
}

//+----------------------------------------------------------------------------------+
//|                                                                                  |
//+----------------------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,limit,counted_bars  = IndicatorCounted();
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(MathMax(Bars-counted_bars,iBarShift(NULL,0,iTime(NULL,PERIOD_D1,0))),Bars-1);
           if (Period()>=PERIOD_D1) { Comment("Indicator should work on time frame less than daily"); return(0); }

   //
   //
   //
   //
   //

   for (i=limit; i>=0; i--)
   {
      datetime tStart = StrToTime(TimeToStr(Time[i],TIME_DATE)+startTime);
      datetime tEnd   = StrToTime(TimeToStr(Time[i],TIME_DATE)+endTime);
      if (Time[i]<tStart)
         {
            tStart -= 24*60*60;
            tEnd   -= 24*60*60;
         }
         
      //
      //
      //
      //
      //
               
      int    iStart = iBarShift(NULL,0,tStart);
      int    iEnd   = iBarShift(NULL,0,tEnd);
      double high   = High[ArrayMaximum(High,iStart-iEnd+1,iEnd)];
      double low    = Low [ArrayMinimum(Low ,iStart-iEnd+1,iEnd)];

            bufferBau[i] = EMPTY_VALUE;
            bufferBad[i] = EMPTY_VALUE;
            bufferBbu[i] = EMPTY_VALUE;
            bufferBbd[i] = EMPTY_VALUE;
            bufferUp[i] = high;   
            bufferDn[i] = low;   
            
            //
            //
            //
            //
            //
                        
            trend[i]    = trend[i+1];
            double price = iMA(NULL,0,1,0,MODE_SMA,PriceToMonitor,i);
               if (price>high)               trend[i] =  1;
               if (price<low)                trend[i] = -1;
               if (price<high && price >low) trend[i] =  0;
               if (trend[i] ==  0) { bufferBbu[i] = High[i]; bufferBbd[i] = Low[i]; }
               if (trend[i] ==  1) { bufferBau[i] = High[i]; bufferBad[i] = Low[i]; }
               if (trend[i] == -1) { bufferBad[i] = High[i]; bufferBau[i] = Low[i]; }
   }         
   return(0);
}


//+----------------------------------------------------------------------------------+
//|                                                                                  |
//+----------------------------------------------------------------------------------+
//
//
//
//
//

string normalizeTime(string time)
{
   int sepAt  = StringFind(time,":",0);
   int hour   = StrToInteger(StringSubstr(time,0,sepAt));
   int minute = StrToInteger(StringSubstr(time,sepAt+1,0));
   
   //
   //
   //
   //
   //
   
   hour   = MathMax(MathMin(hour  ,24),0);
   minute = MathMax(MathMin(minute,59),0);
   string answer="";
      while(true)
      {
         if (hour==0) { answer="00";     break; }
         if (hour<10) { answer="0"+hour; break; }
                        answer=    hour; break; 
      }                        
      while(true)
      {
         if (minute==0) { answer=answer+":00";       break; }
         if (minute<10) { answer=answer+":0"+minute; break; }
                          answer=answer+":" +minute; break; 
      }
   return(" "+answer); 
}